#include <windows.h>
#include <string.h>
#include <stdio.h>
#include "menu_windows.h"


LRESULT CALLBACK WindowFunc(HWND, UINT, WPARAM, LPARAM);
static HINSTANCE hInst;

int WINAPI WinMain(HINSTANCE hThisInst, HINSTANCE hPrevInst,
				LPSTR lpszArgs, int nWinMode)
{
  HWND hwnd;
  MSG msg;
  WNDCLASSEX wcl;

  /* Define a window class */
  wcl.cbSize = sizeof(WNDCLASSEX);
  wcl.hInstance = hThisInst;
  wcl.lpszClassName = "MyWin";
  wcl.lpfnWndProc = WindowFunc;
  wcl.style = 0;

  wcl.hIcon = LoadIcon(NULL, IDI_APPLICATION);
  wcl.hIconSm = LoadIcon(NULL, IDI_WINLOGO);
  wcl.hCursor = LoadCursor(NULL, IDC_ARROW);

  wcl.lpszMenuName = "smm";

  wcl.cbClsExtra = 0;
  wcl.cbWndExtra = 0;

  wcl.hbrBackground = GetStockObject(WHITE_BRUSH);

  if (!RegisterClassEx(&wcl))
	  return 0;

  hwnd = CreateWindow(
	  "MyWin",
	  "SMM Title",
	  WS_OVERLAPPEDWINDOW,
	  CW_USEDEFAULT,
	  CW_USEDEFAULT,
	  CW_USEDEFAULT,	/* width */
	  CW_USEDEFAULT,	/* height */
	  HWND_DESKTOP,		/* no parent */
	  NULL,
	  hThisInst,
	  NULL);

  hInst = hThisInst;
  ShowWindow(hwnd, nWinMode);
  UpdateWindow(hwnd);

  while(GetMessage(&msg, NULL, 0, 0)) {
	  TranslateMessage(&msg);
	  DispatchMessage(&msg);
  }

  return msg.wParam;
}

static void loadUI(HWND hwnd)
{
  HWND txt2;
  HWND txt3;
  HWND txt4;
  HWND txt1 = CreateWindow("STATIC", "Image Server Node",
						    WS_CHILD | WS_EX_RIGHT,
							10, 10,
							200, 20,
							hwnd,
							0,
							hInst,
							NULL);
  ShowWindow(txt1, SW_SHOW);

  txt2 = CreateWindow("STATIC", "Image Server Port",
					  WS_CHILD | WS_EX_RIGHT,
					  10, 40,
					  200, 20,
					  hwnd,
					  0,
					  hInst,
					  NULL);
  ShowWindow(txt2, SW_SHOW);

  txt3 = CreateWindow("STATIC", "Called AE Title (remote)",
					  WS_CHILD | WS_EX_RIGHT,
					  10, 70,
					  200, 20,
					  hwnd,
					  0,
					  hInst,
					  NULL);
  ShowWindow(txt3, SW_SHOW);

  txt4 = CreateWindow("STATIC", "Calling AE Title",
					  WS_CHILD | WS_EX_RIGHT,
					  10, 100,
					  150, 20,
					  hwnd,
					  0,
					  hInst,
					  NULL);
  ShowWindow(txt4, SW_SHOW);
#if 0
  HWND hButton = CreateWindow("BUTTON", "Search",
							   WS_CHILD | BS_PUSHBUTTON | WS_VISIBLE,
							   10, 10,
							   100, 100,
							   hwnd,
							   0,
							   hInst,
							   NULL);
  ShowWindow(hButton, SW_SHOW);
#endif
}

LRESULT CALLBACK WindowFunc(HWND hwnd, UINT msg,
							WPARAM wParam, LPARAM lParam)
{
  int response;
  char fileNameString[1024] = "";
  OPENFILENAME fname;

  switch(msg) {
  case WM_CREATE:
	  loadUI(hwnd);
	  break;
  case WM_QUERYNEWPALETTE:
	  //displayQueryNewPalette(hwnd);
	  break;
  case WM_PALETTECHANGED:
	  //displayPaletteChanged(hwnd);
	  break;
  case WM_PAINT:
	  // displayRepaint(hwnd);
	  break;
  case WM_COMMAND:
	  switch (LOWORD(wParam)) {
#if 0
	  case IDM_OPEN:
		  memset(&fname, 0, sizeof(fname));
		  fname.lStructSize = sizeof(fname);
		  fname.hwndOwner = hwnd;
		  fname.lpstrFile = fileNameString;
		  fname.nMaxFile = sizeof(fileNameString);
		  if (GetOpenFileName(&fname))
			  displayDICOMImage(hwnd, fileNameString);
		  break;
#endif
	  case IDM_EXIT:
		  PostQuitMessage(0);
		  break;
	  default:
		  return DefWindowProc(hwnd, msg, wParam, lParam);
	  }
	  break;
  case WM_DESTROY:
	  PostQuitMessage(0);
	  break;
  default:
	  return DefWindowProc(hwnd, msg, wParam, lParam);
  }

  return 0;
}
